<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class CombinacaoProduto {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function getReport($conditions){
        try{
            $params = array (
                ':DTINI'      => $conditions['DTENTRVENDA'][0], 
                ':DTFIM'      => $conditions['DTENTRVENDA'][1], 
                ':CDFILIAL'   => array_key_exists('CDFILIAL', $conditions)    ? implode('_', $conditions['CDFILIAL']) : NULL, 
                ':TCDFILIAL'  => (!array_key_exists('CDFILIAL', $conditions)) ? 'T' : NULL, 
                ':NRORG'      => $conditions['NRORG'], 
                ':TCDPRODUTO' => NULL,
                ':CDPRODLIST' => array_key_exists('CDPRODUTO', $conditions)  ? implode('_', $conditions['CDPRODUTO']) : NULL,
                ':CDARVPRODF' => array_key_exists('CDARVPRODF', $conditions) ? $conditions['CDARVPRODF'] : NULL,
                ':CDARVPRODI' => array_key_exists('CDARVPRODI', $conditions) ? $conditions['CDARVPRODI'] : NULL,
                ':PRODNIV'    => array_key_exists('PRODNIV', $conditions)    ? $conditions['PRODNIV']    : NULL
            );
            
            $prodPai = $this->entityManager->getConnection()->fetchAll(self::GET_PROD_PAI, $params);
            unset($params);
            $resposta = array();
            $rowFilho = array();
            if($prodPai){
                foreach($prodPai as $prod){
                    $params = array(
                        ':DTINI'      => $conditions['DTENTRVENDA'][0],
                        ':DTFIM'      => $conditions['DTENTRVENDA'][1],
                        ':CDPRODPAI'  => $prod['CDPRODPAI'],
                        ':CDFILIAL'   => $prod['CDFILIAL']
                    );
                    $prodFilho   = $this->entityManager->getConnection()->fetchAll(self::GET_PROD_FILHO, $params);
                    if($prodFilho){
                        foreach ($prodFilho as $prodSon){
                            $rowFilho['LABELFILIAL']  = $prod["CDFILIAL"]." - ".$prod["NMFILIAL"];
                     		$rowFilho['CDSUBPRODFIL'] = $prodSon['CDSUBPRODFIL'];
                     		$rowFilho['NMSUBPRODFIL'] = $prodSon['NMSUBPRODFIL'];
                     		$rowFilho['QUANTPRODFIL'] = $prodSon['QUANTPRODFIL'];
                     		$rowFilho['TOTALVENDFIL'] = $prodSon['TOTALVENDFIL'];
                     		$rowFilho['VRLIQ'] = $prodSon['VRLIQ'];
                     		$rowFilho['TXAFINIDADE'] = $prodSon['QUANTPRODFIL']/$prod['QUANTPRODPAI']*100;
                     	    $rowFilho['LABELCOMBPROD'] = $prod['CDPRODPAI'].' - '.$prod['NMPRODPAI'].
                     		' | Valor Vendido '.number_format($prod['TOTALVENDA'], 2).' | Quantidade Vendida '.number_format($prod['QUANTPRODPAI'],3).
                     		' | Nr. de Cupons '.$prod['NRCUPONS'].' | Valor Médio Cupom '.number_format(($prod['TOTALVENDA']/$prod['NRCUPONS']),2);
                     		array_push($resposta, $rowFilho);
                        }
                    }
                }
            }
            return $resposta;
        } catch(Exception $e){
            throw $e;
        }
    }
	
	const GET_PROD_PAI = "
	    SELECT IT.CDPRODUTO AS CDPRODPAI, VE.CDFILIAL, VE.NMFILIAL,
           PR.NMPRODPAI, PR.CDARVPROD, PR.CDBARPRODPAI,
           COUNT(DISTINCT VE.CDFILIAL||VE.CDCAIXA||VE.NRSEQVENDA) AS NRCUPONS, SUM(IT.QTPRODVEND) AS QUANTPRODPAI,
           SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2)) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVENDA
        FROM (SELECT DISTINCT V.CDCAIXA, V.CDFILIAL, FI.NMFILIAL, V.NRSEQVENDA, V.NRORG
                FROM VENDA V, (SELECT DISTINCT L.*, C.CDCAIXA
                                 FROM CAIXA C, (SELECT DISTINCT F.*, L.CDLOJA
                                                  FROM LOJA L, (SELECT DISTINCT CDFILIAL, NMFILIAL
                                                                  FROM FILIAL
                                                                 WHERE (INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T')) F
                                                 WHERE L.CDFILIAL = F.CDFILIAL) L
                                WHERE C.CDFILIAL = L.CDFILIAL
                                  AND C.CDLOJA = L.CDLOJA) FI
               WHERE V.CDCAIXA = FI.CDCAIXA
                 AND V.CDLOJA = FI.CDLOJA
                 AND V.CDFILIAL = FI.CDFILIAL
                 AND V.IDSITUVENDA = 'O'
                 AND V.NRORG = :NRORG
                 AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIM) VE,
    
             (SELECT NMPRODUTO AS NMPRODPAI, CDARVPROD, CDBARPRODUTO AS CDBARPRODPAI, CDPRODUTO, NRORG
                FROM PRODUTO
               WHERE (((((INSTR(:CDPRODLIST, CDPRODUTO) > 0 ) OR (CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
                     AND NRORG = :NRORG) PR, ITEMVENDA IT
        WHERE IT.CDPRODUTO = PR.CDPRODUTO
          AND IT.NRSEQVENDA = VE.NRSEQVENDA
          AND IT.CDFILIAL = VE.CDFILIAL
          AND IT.CDCAIXA = VE.CDCAIXA
          AND ((INSTR(:CDFILIAL, IT.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
          AND VE.NRORG = IT.NRORG
        GROUP BY VE.CDFILIAL, VE.NMFILIAL, IT.CDPRODUTO, PR.NMPRODPAI, PR.CDARVPROD, PR.CDBARPRODPAI
        ORDER BY VE.CDFILIAL, PR.NMPRODPAI";
	
	const GET_PROD_FILHO = "
	    SELECT IT.CDPRODUTO AS CDSUBPRODFIL, PR.NMPRODUTO AS NMSUBPRODFIL, PR.CDBARPRODUTO AS CDBARPRODFIL, SUM(IT.QTPRODVEND) AS QUANTPRODFIL, 
           SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2)) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVENDFIL,
           SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2)) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0) - (IP.VRIMPOPRODIT)) AS VRLIQ
        FROM (SELECT DISTINCT V.CDCAIXA, V.CDFILIAL, V.NRSEQVENDA
                FROM VENDA V, (SELECT DISTINCT L.*, C.CDCAIXA
                                 FROM CAIXA C, (SELECT DISTINCT F.*, L.CDLOJA
                                                  FROM LOJA L, (SELECT DISTINCT CDFILIAL
                                                                  FROM FILIAL
                                                                 WHERE CDFILIAL = :CDFILIAL) F
                                                 WHERE L.CDFILIAL = F.CDFILIAL) L
                                WHERE C.CDFILIAL = L.CDFILIAL
                                  AND C.CDLOJA = L.CDLOJA) FI
               WHERE V.CDCAIXA = FI.CDCAIXA
                 AND V.CDLOJA = FI.CDLOJA
                 AND V.CDFILIAL = FI.CDFILIAL
                 AND V.IDSITUVENDA = 'O'
                 AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIM
                 AND EXISTS (SELECT IT.CDFILIAL
                               FROM ITEMVENDA IT
                              WHERE (IT.CDPRODUTO = :CDPRODPAI)
                                AND (IT.CDFILIAL = V.CDFILIAL)
                                AND (IT.NRSEQVENDA = V.NRSEQVENDA)
                                AND (IT.CDCAIXA = V.CDCAIXA))) VE, PRODUTO PR, ITVENDAIMPOS IP, ITEMVENDA IT
        WHERE
           (VE.CDFILIAL     = IT.CDFILIAL    ) AND 
           (VE.CDCAIXA      = IT.CDCAIXA     ) AND 
           (VE.NRSEQVENDA   = IT.NRSEQVENDA  ) AND
           (IT.CDFILIAL     = IP.CDFILIAL    ) AND 
           (IT.NRSEQVENDA   = IP.NRSEQVENDA  ) AND 
           (IT.CDCAIXA      = IP.CDCAIXA     ) AND 
           (IT.NRSEQUITVEND = IP.NRSEQUITVEND) AND 
           (IT.CDPRODUTO    = PR.CDPRODUTO   ) AND 
           (IT.CDPRODUTO   <> :CDPRODPAI     )
        GROUP BY
           IT.CDPRODUTO, PR.NMPRODUTO, PR.CDBARPRODUTO
        ORDER BY 4 DESC";
}
