<?php
namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class EnvioCupomEmailService {
	protected $entityManager;
	
	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function findSales ($params) {
	    return $this->entityManager->getConnection()->fetchAll(self::FIND_SALES, $params);
	}
	
	public function getSMTPConfig ($NRORG) {
	    $params = array (
	        "NRORG" => $NRORG
	    );
	    
	    return $this->entityManager->getConnection()->fetchAll(self::SMTP_CONFIG, $params);
	}
	
	public function updateStatusEmail ($status, $message, $CDFILIAL, $CDCAIXA, $NRSEQVENDA) {
	    $params = array (
	        "P_IDSITENVCUPOM" => $status,
	        "P_DSRETENVCUPOM" => $message,
	        "P_CDFILIAL" => $CDFILIAL,
            "P_CDCAIXA" => $CDCAIXA,
            "P_NRSEQVENDA" => $NRSEQVENDA
        );
        
        return $this->entityManager->getConnection()->executeQuery(self::UPDT_SALE_EMAIL_STATUS, $params);
	}
	
	public function updateRecipient ($recipient, $CDFILIAL, $CDCAIXA, $NRSEQVENDA) {
	    $params = array (
	        "DSEMAILENVCUPOM" => $recipient,
	        "OLD_CDFILIAL" => $CDFILIAL,
            "OLD_CDCAIXA" => $CDCAIXA,
            "OLD_NRSEQVENDA" => $NRSEQVENDA
        );
        
        return $this->entityManager->getConnection()->executeQuery(self::UPDT_SALE_RECIPIENT, $params);
	}
	
	const FIND_SALES = "
        SELECT 'N' AS IDMARCADO,
               V.CDFILIAL, FLC.NMFILIAL, V.CDCAIXA, V.NRSEQVENDA AS NUMSEQVENDA, V.DTENTRVENDA, V.DTVENDA AS DATAVENDA, V.NRNOTAFISCALCE, V.VRTOTVENDA,
               C.NMCONSUMIDOR, V.DSEMAILENVCUPOM, V.NRACESSONFCE, V.IDSITENVCUPOM, V.DTHRENVCUPOM,
               V.DSRETENVCUPOM
          FROM VENDA V LEFT JOIN (SELECT DISTINCT C.CDCLIENTE, C.CDCONSUMIDOR, C.NMCONSUMIDOR
                                    FROM CONSUMIDOR C, CLIENFILIAL CF
                                   WHERE C.CDCLIENTE = CF.CDCLIENTE
                                     AND ((INSTR(:P_CDFILIAL, CF.CDFILIAL)>0) OR (:P_CDFILIAL = 'T'))
                                     AND ((INSTR(:P_CDCONS, C.CDCONSUMIDOR)>0) OR (:P_CDCONS = 'T'))) C
                              ON V.CDCLIENTE = C.CDCLIENTE
                             AND V.CDCONSUMIDOR = C.CDCONSUMIDOR,
               (SELECT CDFILIAL, NMFILIAL, CDCAIXA, CDLOJA
                  FROM V_FILIALLOJACAIXA
                 WHERE ((INSTR(:P_CDFILIAL, CDFILIAL)>0) OR (:P_CDFILIAL = 'T'))
                   AND ((INSTR(:P_CDCAIXA, CDCAIXA)>0) OR(:P_CDCAIXA = 'T'))
                   AND ((INSTR(:P_CDLOJA, CDLOJA)>0) OR(:P_CDLOJA = 'T'))) FLC
         WHERE V.CDFILIAL = FLC.CDFILIAL
           AND V.CDCAIXA = FLC.CDCAIXA
           AND V.CDLOJA = FLC.CDLOJA
           AND V.DTENTRVENDA BETWEEN :P_DTINICIAL AND :P_DTFINAL
           AND (((UPPER(V.DSEMAILENVCUPOM) LIKE UPPER(:P_DSEMAILCUPOM)||'%') AND (:P_DSEMAILCUPOM <> 'T')) OR
                (:P_DSEMAILCUPOM = 'T'))
           AND ((NRACESSONFCE = :P_DSCHAVE) OR ('T' = :P_DSCHAVE))
           AND V.IDSITUVENDA = 'O'
           AND ((INSTR(:P_DSVENDA, V.NRSEQVENDA)>0 AND :P_DSVENDA <> 'T') OR (:P_DSVENDA = 'T'))
           AND INSTR(:P_STATUSENVIO, IDSITENVCUPOM) > 0
         ORDER BY V.CDFILIAL, V.CDCAIXA, V.DTENTRVENDA, V.CDCONSUMIDOR, V.VRTOTVENDA
	";
	
	const SMTP_CONFIG = "
	    SELECT 
	        DSSMTPAUTVND, DSEMAILAUVND, NRPORTAAUTVND, CDSENHAAUTVNDWEB, DSEMAILCLUSO, DSSMTPCRIPT, IDTPAUTHSMTP, USUARIOSMTP, 
	        DSSMTPLOGIN, DSMSGCUPOMEMAIL, HRENVCUPOMEMAIL, DSDIRPROJENVCUP, NRORG
        FROM PARAMGERAL WHERE NRORG = :NRORG
	";
	
	const UPDT_SALE_EMAIL_STATUS = "
    	UPDATE VENDA
           SET IDSITENVCUPOM = :P_IDSITENVCUPOM,
               DSRETENVCUPOM = :P_DSRETENVCUPOM,
               DTHRENVCUPOM = SYSDATE
         WHERE CDFILIAL = :P_CDFILIAL
           AND CDCAIXA = :P_CDCAIXA
           AND NRSEQVENDA = :P_NRSEQVENDA
	";
	
	const UPDT_SALE_RECIPIENT = "
	    UPDATE VENDA
           SET DSEMAILENVCUPOM = :DSEMAILENVCUPOM
         WHERE CDFILIAL = :OLD_CDFILIAL
           AND CDCAIXA = :OLD_CDCAIXA
           AND NRSEQVENDA = :OLD_NRSEQVENDA
	";
}